"use strict";

// Wrap everything in an anonymous function to avoid polluting the global namespace
(function() {
  // Use the jQuery document ready signal to know when everything has been initialized
  $(document).ready(function() {
    // update status text
    let statusTextDiv = document.getElementById("statusTextDiv");
    statusTextDiv.innerHTML = "Loading...";

    //alert("Loading....");

    // Tell Tableau we'd like to initialize our extension
    tableau.extensions.initializeAsync().then(function() {
      // update status text
      //showStatusBriefly("Extension initialized", 0.5);
      let statusTextDiv = document.getElementById("statusTextDiv");
      statusTextDiv.innerHTML = "Extension initialized.";

      // set the tableau user id in a javascript variable
      setUserId();

      // hide form inputs and button if settings already saved
      //alert(tableau.extensions.settings.get("modelFileName"));
      if (
        tableau.extensions.settings.get("modelFileName") !== undefined &&
        tableau.extensions.settings.get("modelFileName") != ""
      ) {
        // hide form
        document.getElementById("formInputsDiv").style.display = "none";
        document.getElementById("headerTag").style.display = "none";
        document.getElementById("signInButton").style.display = "none";

        // show the open model button
        document.getElementById("openModelButton").style.display = "none";

        // if model is not open this will open it
        //setTimeout(checkIfModelIsOpen, 5000);

        // make form narrow since we are just showing "Open model" (or "Reopen model")
        document.getElementById("theForm").style.width = "120px";
        document.getElementById("secondBr").style.display = "none";
      } else {
        // hide form
        document.getElementById("formInputsDiv").style.display = "inline";
        document.getElementById("headerTag").style.display = "block";
        document.getElementById("signInButton").style.display = "inline";

        // show the open model button
        //document.getElementById("openModelButton").style.display = "none";
      }
    });
  });
})();

function getSelectedSheet(worksheetName) {
  // Go through all the worksheets in the dashboard and find the one we want
  return tableau.extensions.dashboardContent.dashboard.worksheets.find(function(
    sheet
  ) {
    return sheet.name === worksheetName;
  });
}
