var choiceMenuItemsExt;
var selectedItemExt;
var selectedNodeId;
var choiceNodeInfos = {};

// Is model opened, boolean flag set to true
// after checkIfModelIsOpen() returns "yes"
var isModelOpen = false;
var numberOfTimesIsModelOpenedCalled = 0;

var tableauUserId = "";

////////////////////////////////////////////////////
//
// onLoad
//
// When page is loaded.  Initial idea is to sign in and open the model.
// If page is reloaded and the model is already open, then don't reopen.
//
//function onLoad(event) {
//alert("onLoad - " + event)
//signInAcp("tableau@lumina.com", "1", "Lumina");
//}

/////////////////////////////////////////////////////
//
// checkIfModelIsOpen
//
// Calls ACP's IsModelOpen web service.  Will be used initially
// by User input extension.
//
function checkIfModelIsOpen() {
  // update status text
  // document.getElementById('status').innerHTML =  "Signing into ACP...";

  // build the soap request string
  var soapSigninRequest = addSoapEnvelop(
    `<IsModelOpen xmlns="http://tempuri.org/"></IsModelOpen>`
  );

  // Send the Soap request as a POST
  var xmlhttp = getXMLHttpRequest();

  // async callback, handles soap response
  xmlhttp.onreadystatechange = function() {
    if (xmlhttp.readyState == 4) {
      if (xmlhttp.status == 200) {
        // res will be "yes" or "no"
        let res = xmlhttp.responseXML.getElementsByTagName(
          "IsModelOpenResult"
        )[0].innerHTML;

        //alert("res is " + res);

        if (res === "no") {
          // line breakds so status text appears at top
          document.getElementById("firstBr").style.display = "none";
          document.getElementById("secondBr").style.display = "none";
          document.getElementById("anotherBr").style.display = "none";

          // sign in and open the model
          signInAcpAndOpenModel();
        } else {
          // set isModleOpen flag
          isModelOpen = true;

          // line breakds so status text appears at top
          document.getElementById("firstBr").style.display = "none";
          document.getElementById("secondBr").style.display = "none";
          document.getElementById("anotherBr").style.display = "none";

          let statusTextDiv = document.getElementById("statusTextDiv");
          statusTextDiv.innerHTML = "Model is open.";
        }
      }
    }
  };

  // send the soap request
  xmlhttp.send(soapSigninRequest);
}

/////////////////////////////////////////////////////
//
// signInAcp
//
// Calls ACP's LoginV3 web service.
//
function signInAcp(email, pass, subscriptionName) {
  // update status text
  // document.getElementById('status').innerHTML =  "Signing into ACP...";

  // build the soap request string
  var soapSigninRequest = addSoapEnvelop(
    `<LoginV3 xmlns="http://tempuri.org/"><id>${email}</id><pass>${pass}</pass><subscriptionName>${subscriptionName}</subscriptionName></LoginV3>`
  );

  // Send the Soap request as a POST
  var xmlhttp = getXMLHttpRequest();

  // async callback, handles soap response
  xmlhttp.onreadystatechange = function() {
    if (xmlhttp.readyState == 4) {
      if (xmlhttp.status == 200) {
        var handleErrorResult = handleSoapErrorIfPresent(xmlhttp);
        if (handleErrorResult == "no error present") {
          getModelsList("", "", "");

          // update status text
          let statusTextDiv = document.getElementById("statusTextDiv");
          statusTextDiv.innerHTML =
            "Sign successful.<br>Getting list of models...";
        }
      }
    }
  };

  // update status text
  let statusTextDiv = document.getElementById("statusTextDiv");
  statusTextDiv.innerHTML = "Signing into ACP...";

  // send the soap request
  xmlhttp.send(soapSigninRequest);
}

/////////////////////////////////////////////////////
//
// signInAcp
//
// Calls ACP's LoginV3 web service and then opens model.
//
function signInAcpAndOpenModel() {
  // update status text
  // document.getElementById('status').innerHTML =  "Signing into ACP...";

  const subscriptionName = tableau.extensions.settings.get("groupname");
  const email = tableau.extensions.settings.get("emailAddress");
  const pass = tableau.extensions.settings.get("password");

  //alert(subscriptionName);

  // build the soap request string
  var soapSigninRequest = addSoapEnvelop(
    `<LoginV3 xmlns="http://tempuri.org/"><id>${email}</id><pass>${pass}</pass><subscriptionName>${subscriptionName}</subscriptionName></LoginV3>`
  );

  // Send the Soap request as a POST
  var xmlhttp = getXMLHttpRequest();

  // async callback, handles soap response
  xmlhttp.onreadystatechange = function() {
    if (xmlhttp.readyState == 4) {
      if (xmlhttp.status == 200) {
        var handleErrorResult = handleSoapErrorIfPresent(xmlhttp);
        if (handleErrorResult == "no error present") {
          const modelName = tableau.extensions.settings.get("modelFileName");
          openModelAcp(modelName, "", "true");

          // update status text
          let statusTextDiv = document.getElementById("statusTextDiv");
          statusTextDiv.innerHTML = "Sign successful.<br>Opening model...";
        }
      }
    }
  };
  // update status text
  let statusTextDiv = document.getElementById("statusTextDiv");
  statusTextDiv.innerHTML = "Signing into ACP...";

  // send the soap request
  xmlhttp.send(soapSigninRequest);
}
/////////////////////////////////////////////////////
//
// GetModelsListV2
//
// Calls ACP's GetModelsListV2 web service.  And then handles the result by creating
// pulldown menu's for Projects and Models
//
function getModelsList(folderNumber, projectName, uploadFileName) {
  // update status text
  // document.getElementById('status').innerHTML =  "Signing into ACP...";

  // build the soap request string
  var soapSigninRequest = addSoapEnvelop(
    `<GetModelsListV2 xmlns="http://tempuri.org/"><folderNumber>${folderNumber}</folderNumber><projectName>${projectName}</projectName><uploadFileName>${uploadFileName}</uploadFileName></GetModelsListV2>`
  );

  // Send the Soap request as a POST
  var xmlhttp = getXMLHttpRequest();

  // async callback, handles soap response
  xmlhttp.onreadystatechange = function() {
    if (xmlhttp.readyState == 4) {
      if (xmlhttp.status == 200) {
        var handleErrorResult = handleSoapErrorIfPresent(xmlhttp);
        if (handleErrorResult == "no error present") {
          // update status text
          let statusTextDiv = document.getElementById("statusTextDiv");
          statusTextDiv.innerHTML = "";

          // make projects and models pulldowns visible
          document.getElementById("projectsAndModels").style.display = "inline";

          // show "Save these settings" button and hide "Sign on" button
          document.getElementById("saveSettingsButton").style.display =
            "inline";
          document.getElementById("signInButton").style.display = "none";

          saveSettingsButton;
          // change form button text
          //document.getElementById("formButton").innerHTML =
          //"Save these settings";

          //alert('break here');
          //makeChoiceSelect([20,30,40], 1)
          //alert(xmlhttp.responseText);
          const responseXML = xmlhttp.responseXML;
          //const projectsXML = responseXML.getElementsByTagName("projects")[1];
          const projectsArray = responseXML
            .getElementsByTagName("projects")[0]
            .getElementsByTagName("string");

          /*
          let j;
          for (j = 0; j < projectsArray.length; j++) {
            alert(projectsArray[j].innerHTML);
          }
          */

          const selectedItem = responseXML.getElementsByTagName(
            "selectedProject"
          )[0].innerHTML;

          let j;
          let options = "";
          for (j = 0; j < projectsArray.length; j++) {
            let selected = "";
            if (selectedItem === projectsArray[j].innerHTML)
              selected = " selected";

            let option = `<option value="${projectsArray[j].innerHTML}"${selected}>${projectsArray[j].innerHTML}</option>`;

            options += option;
          }

          document.getElementById("projects").innerHTML = options;

          const UploadFileInfo = responseXML.getElementsByTagName(
            "uploadedFiles"
          )[0];
          const fileInfos = responseXML.getElementsByTagName("UploadFileInfo");

          options = "";
          for (j = 0; j < fileInfos.length; j++) {
            const fileName = fileInfos[j].getElementsByTagName("name")[0]
              .innerHTML;
            //alert(fileName);
            let option = `<option value="${fileName}">${fileName}</option>`;
            options += option;
          }

          document.getElementById("models").innerHTML = options;
          return;
          var resXml = xmlhttp.responseXML;
          var nodeDrawingObjects = resXml.getElementsByTagName(
            "NodeDrawingObject"
          );

          let i = 0;
          for (; i < nodeDrawingObjects.length; i++) {
            // get id of the original node which will be used to update the variable's definition
            const defOriginal = nodeDrawingObjects[i].getElementsByTagName(
              "defOriginal"
            )[0].innerHTML;

            let choicePosition = defOriginal.toLowerCase().indexOf("choice(");
            //alert(defOriginal);
            //alert(choicePosition);

            if (choicePosition === -1) {
              insertTextUserInput(nodeDrawingObjects[i]);
            } else {
              insertChoiceUserInput(nodeDrawingObjects[i]);
            }

            // adds a spacer between inputs
            let acpUserInputs = document.getElementById("acpUserInputs");
            acpUserInputs.innerHTML += `<div
			  style="background-color:white;width: 200px;height:5px; font-size: 10pt;padding: 1px;"
			></div>`;
          }
        }
      }
    }
  };

  // send the soap request
  xmlhttp.send(soapSigninRequest);
}

/////////////////////////////////////////////////////
//
// getDiagramInputs
//
// Calls ACP's getDiagramInputs web service.  And then handles the result by creating
// html for the inputs.
//
function getDiagramInputs(modId, modelId) {
  // update status text
  // document.getElementById('status').innerHTML =  "Signing into ACP...";

  // build the soap request string
  var soapSigninRequest = addSoapEnvelop(
    `<GetDiagramInputs xmlns="http://tempuri.org/"><modId>${modId}</modId><modelId>${modelId}</modelId></GetDiagramInputs>`
  );

  // Send the Soap request as a POST
  var xmlhttp = getXMLHttpRequest();

  // async callback, handles soap response
  xmlhttp.onreadystatechange = function() {
    if (xmlhttp.readyState == 4) {
      if (xmlhttp.status == 200) {
        var handleErrorResult = handleSoapErrorIfPresent(xmlhttp);
        if (handleErrorResult == "no error present") {
          //
          //alert('break here');
          //makeChoiceSelect([20,30,40], 1)

          var resXml = xmlhttp.responseXML;
          var nodeDrawingObjects = resXml.getElementsByTagName(
            "NodeDrawingObject"
          );

          let i = 0;
          for (; i < nodeDrawingObjects.length; i++) {
            // get id of the original node which will be used to update the variable's definition
            const defOriginal = nodeDrawingObjects[i].getElementsByTagName(
              "defOriginal"
            )[0].innerHTML;

            let choicePosition = defOriginal.toLowerCase().indexOf("choice(");
            //alert(defOriginal);
            //alert(choicePosition);

            if (choicePosition === -1) {
              insertTextUserInput(nodeDrawingObjects[i]);
            } else {
              insertChoiceUserInput(nodeDrawingObjects[i]);
            }

            // adds a spacer between inputs
            let acpUserInputs = document.getElementById("acpUserInputs");
            acpUserInputs.innerHTML += `<div
			  style="background-color:white;width: 200px;height:5px; font-size: 10pt;padding: 1px;"
			></div>`;
          }
        }
      }
    }
  };

  // send the soap request
  xmlhttp.send(soapSigninRequest);
}

//////////////////////////////////////
//
// insertTextUserInput
//
// Adds a terxt input corresponding to a text user input from the model.
//
function insertTextUserInput(nodeDrawingObject) {
  // get the inputs title
  const inputTitle = nodeDrawingObject.getElementsByTagName("nodetitle")[0]
    .innerHTML;

  // get id of the original node which will be used to update the variable's definition
  const nodeidOriginal = nodeDrawingObject.getElementsByTagName(
    "nodeidOriginal"
  )[0].innerHTML;

  // get id of the original node which will be used to update the variable's definition
  const defOriginal = nodeDrawingObject.getElementsByTagName("defOriginal")[0]
    .innerHTML;
  // alert(defOriginal);

  let myParent = document.getElementById("acpUserInputs");
  //alert(myParent + " " + myParent.innerHTML);
  myParent.innerHTML =
    myParent.innerHTML +
    `<div
			style="background-color:rgb(200,224,246);width: 200px;height:40px; font-size: 10pt;padding: 5px;"
		  >
			${inputTitle}<br /><input id="${nodeidOriginal}" type="text" value="${defOriginal}" onchange="onChangeTextInput(event)" />
		  </div>`;
}

//////////////////////////////////////
//
// insertChoiceUserInput
//
// Adds a terxt input corresponding to a text user input from the model.
//
function insertChoiceUserInput(nodeDrawingObject) {
  // get the inputs title
  const inputTitle = nodeDrawingObject.getElementsByTagName("nodetitle")[0]
    .innerHTML;

  // get id of the original node which will be used to update the variable's definition
  const nodeidOriginal = nodeDrawingObject.getElementsByTagName(
    "nodeidOriginal"
  )[0].innerHTML;

  // get id of the original node which will be used to update the variable's definition
  const defOriginal = nodeDrawingObject.getElementsByTagName("defOriginal")[0]
    .innerHTML;
  alert(defOriginal);

  // let's store the definition in an associative array
  choiceNodeInfos[nodeidOriginal] = defOriginal;

  // get the selected index for the choice menu
  const selectedIndex = nodeDrawingObject.getElementsByTagName(
    "SelectedIndex"
  )[0].innerHTML;

  //
  // get the menu items
  //
  const choiceListItems = nodeDrawingObject.getElementsByTagName(
    "ChoiceListItem"
  );

  let i;
  let options = "";
  for (i = 0; i < choiceListItems.length; i++) {
    let selected = "";
    if (selectedIndex == i) selected = " selected";

    let option = `<option value="${
      choiceListItems[i].getElementsByTagName("data")[0].innerHTML
    }"${selected}>${
      choiceListItems[i].getElementsByTagName("label")[0].innerHTML
    }</option>`;

    options += option;
  }

  // build the select tag (i.e. choice pulldown) html

  let myParent = document.getElementById("acpUserInputs");
  //alert(myParent + " " + myParent.innerHTML);
  myParent.innerHTML =
    myParent.innerHTML +
    `<div
	  style="background-color:rgb(200,224,246);width: 200px;height:40px; font-size: 10pt;padding: 5px;"
	  deforiginal = "${defOriginal}"
	>
	  ${inputTitle}<br />
	  <select id="${nodeidOriginal}" onchange="onChangeChoiceInput(event)" 
		>${options}
	  </select>
	</div>`;
}

/////////////////////////////////////////////////////
//
// setUserId
//
// Sets the Tableau User id in a js variable which can be
// used later to send it to ACP
//
function setUserId() {
  let userIdSheet = getSelectedSheet("userIdSheet");
  userIdSheet.getSummaryDataAsync().then(function(data) {
    //alert("User name: " + data.data[0][0].value);
    tableauUserId = data.data[0][0].value;

    // now that the tableauUserId js variable is set, we can open the model
    // if the extension has been setup (otherwise the model gets opened later after completing the form)
    if (
      tableau.extensions.settings.get("modelFileName") !== undefined &&
      tableau.extensions.settings.get("modelFileName") != ""
    ) {
      checkIfModelIsOpen();
    }
  });
}

//////////////////////////////////////
//
// handleSoapErrorIfPresent
//
// When acp soap web service calls return they will have a Messages object if
// an error occurred.  This function will display that message and more...
//
// Returns:
//
// If there is an error, then returns 'error present'.  If no error, then returns 'no error present'.
function handleSoapErrorIfPresent(soapResponse) {
  var resXml = soapResponse.responseXML;
  var successXml = resXml.getElementsByTagName("Messages");
  var result = "no error present";
  if (successXml.length != 0) {
    // looks there is an message (almost always an Error message) present

    // for now just elect the 'text' of the error message
    alert(
      "Error: " +
        successXml[0].childNodes[0].childNodes[0].childNodes[1].innerHTML // +
      /*" (" +
        successXml[0].childNodes[0].childNodes[0].childNodes[0].innerHTML +
        ")"*/
    );
    result = "Error present";
  }

  return result;
}
//////////////////////////////////////
//
//  openModelAcp
//
//
// Calls ACP open model web service.
//
// Parameters
//
// modelFileName - name of model e.g. Bond Model.ana
// folderNumber - folder number used in ACP, often this can be left blank
// closeOpenModel - if ACP is already playing a model, thie boolean say whether or not to open the model anyways.  Set this
// to either 'true' or 'false' (text value)
//
function openModelAcp(modelFileName, folderNumber, closeOpenModel) {
  if (tableauUserId == undefined || tableauUserId == "")
    alert("Warning:  Tableau user name is missing. " + tableauUserId);

  // build the soap request string
  var soapRequest = addSoapEnvelop(
    `<OpenModelV3AndAHalf xmlns="http://tempuri.org/"><modelFileName>${modelFileName}</modelFileName><folderIdNumber /><closeOpenModel>${closeOpenModel}</closeOpenModel><urlId>${tableauUserId}</urlId><subscriptionName>Lumina</subscriptionName></OpenModelV3AndAHalf>`
  );
  //alert(soapRequest);

  // Send the Soap request as a POST
  var xmlhttp = getXMLHttpRequest();

  // async callback, handles soap response
  xmlhttp.onreadystatechange = function() {
    if (xmlhttp.readyState == 4) {
      if (xmlhttp.status == 200) {
        var handleErrorResult = handleSoapErrorIfPresent(xmlhttp);
        if (handleErrorResult == "no error present") {
          // update status text
          let statusTextDiv = document.getElementById("statusTextDiv");
          statusTextDiv.innerHTML = "Model is open.";

          // change button text
          //document.getElementById("openModelButton").innerHTML = "Reopen model";

          // hide the button
          document.getElementById("openModelButton").style.display = "none";
          document.getElementById("firstBr").style.display = "none";
          document.getElementById("secondBr").style.display = "none";
          document.getElementById("anotherBr").style.display = "none";
        }
      }
    }
  };

  // send the soap request
  xmlhttp.send(soapRequest);
}

///////////////////////////////////////////////////////////////////////
//
// updateVariableDefinition
//
//
// This function will call ACP's web service for updating a variables definition.  Can be used with text inputs,
// checkboxes, choice inputs etc.
//
// Initially, just have two parameters.
// - variableId
// - newDefinition
function updateVariableDefinition(variableId, newDefinition) {
  // build the soap request string
  var soapRequest = addSoapEnvelop(
    `<tns:UpdateNodeDef xmlns:tns="http://tempuri.org/"><tns:theNodeId>${variableId}</tns:theNodeId><tns:newDef>${newDefinition}</tns:newDef><tns:formnodeId></tns:formnodeId><tns:clickDateTime></tns:clickDateTime></tns:UpdateNodeDef>`
  );
  alert(soapRequest);

  // Send the Soap request as a POST
  var xmlhttp = getXMLHttpRequest();

  // async callback, handles soap response
  xmlhttp.onreadystatechange = function() {
    if (xmlhttp.readyState == 4) {
      if (xmlhttp.status == 200) {
        alert(xmlhttp.responseText);
        var handleErrorResult = handleSoapErrorIfPresent(xmlhttp);
        if (handleErrorResult == "no error present") {
          alert("variable definition updated");

          //return;

          // Get the dashboard
          var dashboard = tableau.extensions.dashboardContent.dashboard;

          // Display the name of dashboard in the UI
          //alert("db name " + dashboard.name);

          // refresh all worksheets
          var i;
          for (i = 0; i < dashboard.worksheets.length; i++) {
            var worksheet = dashboard.worksheets[i];
            //alert(worksheet.name);
            // the example code I saw says if I want to call refreshAsyn worked like this...
            var dataSourcesPromise = worksheet.getDataSourcesAsync();
            //dataSourcesPromise.then(getDataSourcesAsyncCallBack);
            dataSourcesPromise.then(
              arrayOfDataSources => {
                arrayOfDataSources[0].refreshAsync();
              },
              errorObj => {
                alert(
                  "getDataSourcesAsync() promised hit an error. " +
                    errorObj.toString()
                );
              }
            );
          }
        }
      }
    }
  };

  // send the soap request
  xmlhttp.send(soapRequest);
}

////////////////////////////////////////////////////////////////////////
//
//  onChangeChoiceInput
//
// Change handler for choice inputs (i.e. html select pulldowns).
// Will call UpdateNodeDef
function onChangeChoiceInput(event) {
  alert("onChangeInput " + event.target.id);
  alert("old def " + choiceNodeInfos[event.target.id]);

  //
  // update choice() definition
  //
  let newChoiceSecondParameter = event.target.value;
  let newChoiceDef = "";
  let oldChoiceDefintion = choiceNodeInfos[event.target.id];

  // code from actionscript flex, we can use for handling subtable choices
  //
  //if (this.nodeFields.isSubChoice != "true")
  //  strs = this.nodeFields.defOriginal.split(",");
  //else strs = this.nodeFields.subTableChoiceDef.split(",");

  let splitChoiceArray = oldChoiceDefintion.split(",");
  splitChoiceArray[1] = newChoiceSecondParameter;
  newChoiceDef = splitChoiceArray.join(",");

  // so strs.length will be 2 if the choice node only has two parameters.
  // In that case we need to add closing paren
  if (splitChoiceArray.length == 2) newChoiceDef += ")";

  alert("new choice def " + newChoiceDef);
  updateVariableDefinition(event.target.id, newChoiceDef);
}

////////////////////////////////////////////////////////////////////////
//
//  onChangeTextInput
//
// Change handler for choice inputs (i.e. html select pulldowns).
// Will call UpdateNodeDef
function onChangeTextInput(event) {
  alert("onChangeTextInput " + event.target.value);
  updateVariableDefinition(event.target.id, event.target.value);
}

/*
//////////////////////////////////////
//
//  getListofMenuItems
//
//  Calls Typescript web service.  Gets the list of items for the choice pulldown.
//
function getListofMenuItems() {
  // build the soap request string
  var soapRequest = addSoapEnvelop(
    '<tns:TypeScript xmlns:tns="http://tempuri.org/"><tns:command>Definition dashboard_index</tns:command></tns:TypeScript>'
  );
  //alert(soapRequest);

  // Send the Soap request as a POST
  var xmlhttp = getXMLHttpRequest();
  // async callback, handles soap response
  xmlhttp.onreadystatechange = function() {
    if (xmlhttp.readyState == 4) {
      if (xmlhttp.status == 200) {
        //alert(xmlhttp.responseText);

        // extract the list of menu items and store in choiceMenuItemsExt
        var resXml = xmlhttp.responseXML;
        var successXml = resXml.getElementsByTagName("TypeScriptResult")[0];
        choiceMenuItemsExt = successXml.childNodes[0].nodeValue;

        // get the selected item
        document.getElementById("status").innerHTML +=
          " Menu items are " +
          choiceMenuItemsExt +
          ".<br>Getting selected item for pulldown...";
        getSelectedItem();
      }
    }
  };

  // Send the Soap request as a POST
  xmlhttp.send(soapRequest);
}

//////////////////////////////////////
//
//  getSelectedItem
//
//  Calls Typescript web service.  Gets the selected item for the choice pulldown.
//
function getSelectedItem() {
  // build the soap request string
  var soapRequest = addSoapEnvelop(
    '<tns:TypeScript xmlns:tns="http://tempuri.org/"><tns:command>mid(Dashboard_selection)</tns:command></tns:TypeScript>'
  );
  //alert(soapRequest);

  // Send the Soap request as a POST
  var xmlhttp = getXMLHttpRequest();
  xmlhttp.send(soapRequest);

  // async callback, handles soap response
  xmlhttp.onreadystatechange = function() {
    if (xmlhttp.readyState == 4) {
      if (xmlhttp.status == 200) {
        var resXml = xmlhttp.responseXML;
        var successXml = resXml.getElementsByTagName("TypeScriptResult")[0];
        selectedItemExt = successXml.childNodes[0].nodeValue;
        document.getElementById("status").innerHTML +=
          " The selected item is " +
          selectedItemExt +
          ".<br><br>REFRESH VIEW and then change pulldown menu.";
        makeChoiceSelect(eval(choiceMenuItemsExt), selectedItemExt);
      }
    }
  };
}
*/

function addSoapEnvelop(soapRequestWithoutEnvelop) {
  var soapRequestWithEnvelop =
    '<?xml version="1.0" encoding="utf-8"?><SOAP-ENV:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"><SOAP-ENV:Body>';
  soapRequestWithEnvelop +=
    soapRequestWithoutEnvelop + "</SOAP-ENV:Body></SOAP-ENV:Envelope>";
  return soapRequestWithEnvelop;
}

/////////////////////////////////////////////////////////////
//
// getXMLHttpRequest
//
// small helper function which sets up the xmlhttpObject and then returns that object.
function getXMLHttpRequest() {
  var xmlhttpObject = new XMLHttpRequest();
  let url = "https://tableau-dev.analytica.com:8112/acp/AcpService.asmx";
  //url = "http://localhost:12340/AcpService.asmx";
  xmlhttpObject.open("POST", url, true);
  xmlhttpObject.setRequestHeader("Content-Type", "text/xml");
  return xmlhttpObject;
}

////////////////////////////////////////////////////////////////
//
// makeChoiceSelect
//
// Makes an html select item i.e. a pulldown menu like a choice input
function makeChoiceSelect(items, selectedIndex) {
  //var myParent = document.body;
  var myParent = document.getElementById("choiceInputDiv");

  //Create array of options to be added
  var array = items;

  //Create and append select list
  var selectList = document.createElement("select");
  selectList.id = "mySelect";
  myParent.appendChild(selectList);

  //Create and append the options
  for (var i = 0; i < array.length; i++) {
    var option = document.createElement("option");
    option.value = array[i];
    option.text = array[i];
    selectList.appendChild(option);
  }

  selectList.selectedIndex = 1;
  selectList.onchange = onChoiceChange;
}

/////////////////////////////////////////////////////////////////////
//
// onChoiceChange
//
// The onchange event handler for the choice pulldown menu.
//
function onChoiceChange() {
  //alert('onChoiceChange');

  var selList = document.getElementById("mySelect");
  var newDefinition = "";
  if (selList.selectedIndex == 1)
    newDefinition = "dashboard_selection: Choice(Dashboard_index,2,0)";
  else newDefinition = "dashboard_selection: Choice(Dashboard_index,1,0)";
  //alert(newDefinition);
  //sr = '<?xml version="1.0" encoding="utf-8"?><SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:s="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><SOAP-ENV:Body><tns:TypeScript xmlns:tns="http://tempuri.org/"><tns:command>' + newDefinition + '</tns:command></tns:TypeScript></SOAP-ENV:Body></SOAP-ENV:Envelope>';

  // build the soap request string
  var soapRequest = addSoapEnvelop(
    '<tns:TypeScript xmlns:tns="http://tempuri.org/"><tns:command>' +
      newDefinition +
      "</tns:command></tns:TypeScript>"
  );
  //alert(soapRequest);

  // Send the Soap request as a POST
  var xmlhttp = getXMLHttpRequest();

  // async callback, handles soap response
  xmlhttp.onreadystatechange = function() {
    if (xmlhttp.readyState == 4) {
      if (xmlhttp.status == 200) {
        // Get the dashboard
        var dashboard = tableau.extensions.dashboardContent.dashboard;

        // Display the name of dashboard in the UI
        //alert("db name" + dashboard.name);

        // get teh only worksheet
        var worksheet = dashboard.worksheets[0];

        // the example code I saw says if I want to call refreshAsyn worked like this...
        var dataSourcesPromise = worksheet.getDataSourcesAsync();
        //dataSourcesPromise.then(getDataSourcesAsyncCallBack);
        dataSourcesPromise.then(
          arrayOfDataSources => {
            arrayOfDataSources[0].refreshAsync();
          },
          errorObj => {
            alert(
              "getDataSourcesAsync() promised hit an error. " +
                errorObj.toString()
            );
          }
        );
      }
    }
  };

  // send the soap request
  xmlhttp.send(soapRequest);
}

function getDataSourcesAsyncCallBack(arrayOfDataSources) {
  // get the only datasource and call refreshAsync()
  arrayOfDataSources[0].refreshAsync();
}
